import {useState, useCallback} from 'react'

export function usePaginatedFetch(url){
    const [loading, setloading] = useState(false)
    const [items, setItems]= useState([])
    const load = useCallback(async ()=> {
        setloading(true)
        const response = await fetch(url, {
            headers:{
               'Accept':'application/ld+json'
            }
        })
        const responseData=await  response.json()
        if(response.ok){
            setItems(responseData['hydra:member'])
        }else{
            alert(responseData)
        }
        setloading(false)

    },[url])

    return{
        items,
        load,
        loading
    }
}
 