import React, {Component} from 'react';
import {withRouter} from 'react-router-dom';
import { Card, CardText, CardBody,CardTitle, Container,Row, Col, Badge  } from 'reactstrap';
import axios from 'axios';

class FetchResourcePublic extends Component {

    constructor(props) {
        super(props);
        this.state = {
            offres: [],loading:true
        };
        this.fetchPublicResources = this.fetchPublicResources.bind(this);
    }

    componentWillMount() {
        this.fetchPublicResources();
    }

    fetchPublicResources() {
       
            axios.get('http://localhost:8000/api/appel_offres').then(offres => {
                    this.setState({offres: offres.data,loading:false});
                })
        
    }


    render() {
        const loading = this.state.loading;
        return (
            <div>
                <section className="row-section">
                    <div className="container">
                        <div className="row">
                            <h2 className="text-center"><span>Offres</span>test <i
                                className="fa fa-heart"></i> </h2>
                        </div>
                        {loading ? (
                            <div className={'row text-center'}>
                                <span className="fa fa-spin fa-spinner fa-4x"></span>
                            </div>
                        ) : (
                            <div className={'row'}>
                                { this.state.offres.map(offre =>
                                    <div className="col-md-10 offset-md-1 row-block" key={offre.id}>
                                        <ul id="sortable">
                                            <li>
                                                    
                                                    <div className="media-body">
                                                        <h4>{offre.libelle}</h4>
                                                        <p>{offre.date_limite}</p>
                                                    </div>
                                                    <div className="media-right align-self-center">
                                                        <a href="#" className="btn btn-default">Favoris</a>
                                                    </div>
                                            </li>
                                        </ul>
                                    </div>
                                )}
                            </div>
                        )}
                    </div>
                </section>
            </div>
        )
    }
}
export default FetchResourcePublic;