<?php

namespace App\Controller;

use App\Entity\AppelOffre;
use App\Entity\AutoriteContractante;
use App\Entity\TypeMarche;
use Symfony\Component\Routing\Annotation\Route;
use Doctrine\ORM\EntityManagerInterface;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpKernel\Exception\BadRequestHttpException;
use Symfony\Component\HttpFoundation\BinaryFileResponse;
use Symfony\Component\HttpFoundation\ResponseHeaderBag;




/**
 *
 */
class DetailsOffreController 
{
    private $_entityManager;

    public function __construct(
        EntityManagerInterface $entityManager
    ) {
        $this->_entityManager = $entityManager;
    }


    public function __invoke(Request $request): AppelOffre
    {
        $uploadedFile = $request->files->get('file');
        $libelle=$request->request->get('libelle');
        $ref=$request->request->get('ref');
        $lieu=$request->request->get('lieu');
        $ouverture=$request->request->get('ouverture');
        $limite=$request->request->get('limite');
        
        if (!$uploadedFile) {
            throw new BadRequestHttpException('fichier requis');
        }
       
        $mediaObject = new AppelOffre();
        $autorite = $this->_entityManager->getRepository(AutoriteContractante::class)->find($request->request->get('autorite'));
        
        $marche = $this->_entityManager->getRepository(TypeMarche::class)->find($request->request->get('marche'));
       
        $mediaObject->setFile($uploadedFile);
        $mediaObject->setLibelle($libelle);
        $mediaObject->setRef($ref);
        $mediaObject->setLieu($lieu);
        $mediaObject->setOuverture(new \DateTime($ouverture));
        $mediaObject->setLimite(new \DateTime($limite));
        $mediaObject->setAutorite($autorite);
        $mediaObject->setMarche($marche);
        $mediaObject->setPublication(new \DateTime);
        $mediaObject->setFilename($ref);

        $this->_entityManager->persist($mediaObject);

        $this->_entityManager->flush();

        return $mediaObject; 

    }

}