<?php

namespace App\Controller;

use App\Entity\AppelOffre;
use Symfony\Component\Routing\Annotation\Route;
use Symfony\Component\HttpFoundation\BinaryFileResponse;
use Symfony\Component\HttpFoundation\ResponseHeaderBag;
use Doctrine\ORM\EntityManagerInterface;
use Symfony\Component\HttpFoundation\JsonResponse;



/**
 *
 */
class DownloadPdf 
{
    private $_entityManager;

    public function __construct(
        EntityManagerInterface $entityManager
    ) {
        $this->_entityManager = $entityManager;
    }

    /**
     * @Route("/api/download/{id}", name="download_file")
    **/
    public function download($id){
    
        $offre = $this->_entityManager->getRepository(AppelOffre::class)->find($id); 
        $filename=$offre->getFilename();
        if(!$filename){
            return new JsonResponse('Cette offre ne contient pas de détail',200, 
            ['Content-Type' => 'application/json'
            ]);
        }else{
            $response = new BinaryFileResponse( __DIR__.'/../../public/pdf/'.$filename);
            $response->setContentDisposition(ResponseHeaderBag::DISPOSITION_ATTACHMENT,$filename);
            return $response;
        }
        
        
    }

}