<?php

namespace App\Controller;

use ApiPlatform\Core\EventListener\EventPriorities;
use App\Entity\AppelOffre;
use App\Entity\User;
use Symfony\Component\EventDispatcher\EventSubscriberInterface;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpKernel\Event\ViewEvent;
use Symfony\Component\HttpKernel\KernelEvents;

final class UserMailSubscriber implements EventSubscriberInterface
{
    private $mailer;

    public function __construct(\Swift_Mailer $mailer)
    {
        $this->mailer = $mailer;
    }

    public static function getSubscribedEvents()
    {
        return [
            KernelEvents::VIEW => ['sendMail', EventPriorities::POST_WRITE],
        ];
    }

    public function sendMail(ViewEvent $event): void
    {
        $user = $event->getControllerResult();
        $method = $event->getRequest()->getMethod();

        if (!$user instanceof User || Request::METHOD_POST !== $method) {
            return;
        }
        if($user->getRoles()==["ROLE_USER"]){
            $message = (new \Swift_Message('Portail Marchés Publics'))
            ->setFrom('mkene@gainde2000.sn')
            ->setTo($user->getEmail())
           ;
            $message->setBody(
            '<html>' .
            ' <head></head>' .
            ' <body>' .
            $user->getPrenom().
            '</br>' .
            '</br>' .
            ' Bienvenue dans la plateforme de portail des marchés publics. Vous pouvez désormais ajouter des appels d\'offres' .
            '</br>' .
            '</br>' .
            ' Connectez-vous avec le lien suivant pour continuer: ' .
            '<a href="http://localhost:3000/connection"> Se connecter</a>' .
            ' </br></br></br></br> <img src="' .
             $message->embed(\Swift_Image::fromPath(__DIR__.'/../../assets/images/logo.jpg')) .
               '" alt="Gainde 2000" />' .
            ' </body>' .
            '</html>',
              'text/html'
            );
        }else{
            $message = (new \Swift_Message('Portail Marchés Publics'))
            ->setFrom('mkene@gainde2000.sn')
            ->setTo($user->getEmail())
           ;
            $message->setBody(
            '<html>' .
            ' <head></head>' .
            ' <body>' .
            $user->getPrenom().
            '</br>' .
            '</br>' .
            ' Bienvenue dans la plateforme de portail des marchés publics. Vous pouvez désormais ajouter des favoris et créer des alertes' .
            '</br>' .
            '</br>' .
            ' Connectez-vous avec le lien suivant pour continuer: ' .
            '<a href="http://localhost:3000/connection"> Se connecter</a>' .
            ' </br></br></br></br> <img src="' .
             $message->embed(\Swift_Image::fromPath(__DIR__.'/../../assets/images/logo.jpg')) .
               '" alt="Gainde 2000" />' .
            ' </body>' .
            '</html>',
              'text/html'
            );

        }
        
      /*  (sprintf('         %s,

            Bienvenue dans la plateforme de portail des marchés publics.

            Connectez-vous avec le lien suivant pour pouvoir ajouter des appels d\'offres: http://localhost:3000/connection', $user->getPrenom()))
            ;

        $message->attach(\Swift_Attachment::fromPath(__DIR__.'/../../assets/images/logo.jpg')); */


        $this->mailer->send($message);
    }
}