<?php

namespace App\DataFixtures;

use App\Entity\TypeMarche;
use App\Entity\TypeAutorite;
use App\Entity\AutoriteContractante;
use App\Entity\Direction;
use App\Entity\AppelOffre;
use Doctrine\Bundle\FixturesBundle\Fixture;
use Doctrine\Persistence\ObjectManager;

class AppFixtures extends Fixture
{
    public function load(ObjectManager $manager)
    {
        for ($i = 0; $i < 5; $i++) {
            $tm = new TypeMarche();
            $tm->setLibelle('Marche '.$i);
            $manager->persist($tm);
        }

        for ($i = 0; $i < 5; $i++) {
            $tm = new TypeAutorite();
            $tm->setLibelle('Type autorite '.$i);
            $manager->persist($tm);
        }

        for ($i = 0; $i < 10; $i++) {
            $tm = new AutoriteContractante();
            $tm->setLibelle('Autorite '.$i);
            $manager->persist($tm);
            
        }

        for ($i = 0; $i <30 ; $i++) {
            $tm = new Direction();
            $tm->setLibelle('Direction '.$i);
            
            $manager->persist($tm);
        }

        for ($i = 0; $i <10 ; $i++) {
            $tm = new AppelOffre();
            $tm->setLibelle("Appel d'offre numéro ".$i);
            $tm->setDatePublication(new \DateTime);
            $tm->setDateOuverture(new \DateTime);
            $tm->setDateLimite(new \DateTime);
            $tm->setLieuAcquisition('Direction Générale des centres Informatique');
            $tm->setRef('T_ST_124297'.$i);
           
            
            
            $manager->persist($tm);
        }

        $manager->flush();
    }
}
