<?php

namespace App\Entity;

use App\Repository\AlerteRepository;
use Doctrine\ORM\Mapping as ORM;
use ApiPlatform\Core\Annotation\ApiResource;
use App\Controller\AddAlerteController;


/**
 * @ApiResource(
 *   normalizationContext={"groups"={"read:alerte"}},
 *   collectionOperations={
 *         "post"={
 *             "controller"=AddAlerteController::class,
 *             "deserialize"=false,
 *             "path"="/alerte/ajout",
 *             "validation_groups"={"Default", "write:alerte"},
 *             "openapi_context"={
 *                 "requestBody"={
 *                     "content"={
 *                         "multipart/form-data"
 *                     }
 *                 }
 *             }
 *         },
 *         "get"
 *   },  
 * ),
 * @ORM\Entity(repositoryClass=AlerteRepository::class)
 */
class Alerte
{
    /**
     * @ORM\Id
     * @ORM\GeneratedValue
     * @ORM\Column(type="integer")
     */
    private $id;

    /**
     * @ORM\ManyToOne(targetEntity=Abonne::class, inversedBy="alertes")
     */
    private $abonne;

    /**
     * @ORM\ManyToOne(targetEntity=TypeMarche::class, inversedBy="alertes")
     */
    private $marche;

    public function getId(): ?int
    {
        return $this->id;
    }

    public function getAbonne(): ?Abonne
    {
        return $this->abonne;
    }

    public function setAbonne(?Abonne $abonne): self
    {
        $this->abonne = $abonne;

        return $this;
    }

    public function getMarche(): ?TypeMarche
    {
        return $this->marche;
    }

    public function setMarche(?TypeMarche $marche): self
    {
        $this->marche = $marche;

        return $this;
    }
}
